# gotypist-stats

[![PyPI version](https://img.shields.io/pypi/v/gotypist-stats.svg)](https://pypi.org/project/gotypist-stats/)

Parse `~/.gotypist-stats` file generated by [gotypist](https://github.com/pb-/gotypist) and show various stats to get some insights on your progress and performance.

### Currently available:

- 6 month activity hitmap à la Github to track the training sessions
- cumulated time spent on gotypist
- phrase that gave you the biggest trouble ever
- most commons mistyped letters
- character per second progress month over month

### Installation and usage

Requirement: python 3.6+

```shell
pip3 install --user gotypist-stats
gotypist-stats
```

### Example output

```

🟄 6 months hitmap 🟄

Mon ░░▓▓░░░░░░▒▒░░░░░░░░░░░░░░░░▓▓░░░░▒▒░░░░░░░░▓▓░░░░░░░░
Tue ░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░▒▒░░░░░░▓▓░░▓▓▓▓▓▓░░▒▒░░
Wed ░░▓▓░░░░░░░░▒▒░░░░░░░░░░░░░░░░▒▒░░░░░░▓▓▓▓░░░░▓▓░░░░░░
Thu ░░░░░░░░░░░░░░░░░░░░░░░░░░░░▓▓░░░░░░░░░░░░░░░░▓▓░░░░▓▓
Fri ░░░░░░░░░░░░░░░░░░░░▓▓░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
Sat ░░▒▒░░░░░░░░░░▓▓░░░░░░░░░░░░░░░░░░░░░░▓▓░░░░░░▓▓░░░░░░
Sun ░░░░░░░░░░░░░░░░▓▓▒▒░░░░░░░░░░░░░░▓▓▒▒▓▓░░▓▓▓▓░░▒▒▓▓▒▒

🟄 Overall stats 🟄

+----------------------+---------------+
| Total training time: | 4 hours 44min |
+----------------------+---------------+

🟄 Biggest failure 🟄

+---------------+-----------------------------------------------------------------------+
| was typing    | debug=$([[ -z $SQL_OUTPUT ]] && echo '' || echo ".trace $SQL_OUTPUT") |
+---------------+-----------------------------------------------------------------------+
| mode          | slow                                                                  |
+---------------+-----------------------------------------------------------------------+
| failed        | 25 times                                                              |
+---------------+-----------------------------------------------------------------------+
| happened on   | Sep 09 2019                                                           |
+---------------+-----------------------------------------------------------------------+
| struggled for | 7 minutes 9s                                                          |
+---------------+-----------------------------------------------------------------------+

🟄 Most common typos 🟄

    Typo              Mistakes  % of mistakes
--  --------------  ----------  ---------------
 1  s instead of d          54  2.85%
 2  _ instead of )          54  2.85%
 3  r instead of e          53  2.80%
 4  r instead of t          51  2.69%
 5  u instead of i          40  2.11%
 6  [ instead of p          37  1.95%

🟄 Characters per second (slow mode) 🟄

Month       Median cps  Plot                               Sessions
--------  ------------  -------------------------------  -------------
Aug 2017          2.2     ├□□□□□▣□□□□□□□□□□┤                         3
Nov 2018          2.4     ├─□□□□▣□┤                                  7
Apr 2019          0.83  ├□□▣□□─────┤                                48
May 2019          0.53   ▣□□□□┤                                     11
Jun 2019          0.75  ├□▣□□──┤                                    10
Jul 2019          0.77  ├□▣□□□□□────────┤                           11
Aug 2019          0.74  ├□▣□──────┤                                 18
Sep 2019          1.3   ├─□□▣□□□──────────────────┤                 67
Oct 2019          1.3   ├─□□▣□□□□─────────────────────┤             36

```
